#include "ApplyTest.h"
#include <alib/tuple>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ApplyTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( ApplyTest );

void ApplyTest::setUp ( ) {
}

void ApplyTest::tearDown ( ) {
}

class Foo {
public:
};

int tupleTestApply1 ( Foo, Foo ) {
	return 1;
}

int tupleTestApply2 ( int, int ) {
	return 2;
}

void ApplyTest::testApply ( ) {
	std::tuple < int, int > t ( 1, 2 );
	CPPUNIT_ASSERT ( std::apply ( tupleTestApply2, t ) == 2 );
}
